Index: module-camd35-cacheex.c
===================================================================
--- module-camd35-cacheex.c	(revision 11581)
+++ module-camd35-cacheex.c	(working copy)
@@ -13,6 +13,7 @@
 #include "oscam-ecm.h"
 #include "oscam-string.h"
 #include "oscam-reader.h"
+#include "oscam-chk.h"
 
 uint8_t camd35_node_id[8];
 
@@ -21,6 +22,630 @@
                   ((((uint32_t)(n) & 0xFF0000)) >> 8) | \
                   ((((uint32_t)(n) & 0xFF000000)) >> 24))
 
+void camd35_cacheex_feature_trigger_in(struct s_client *cl, uint8_t *buf)
+{
+	int32_t feature = 0;
+	uint16_t i = 20;
+	uint8_t filter_count;
+	uint8_t j;
+	feature = buf[21] | (buf[20] << 8);
+
+	switch(feature)
+	{
+		// set localgenerated only
+		case 1:
+			if(cl->typ == 'c' && cl->account->cacheex.mode == 2)
+			{
+				cl->account->cacheex.localgenerated_only = buf[24];
+			}
+			else if(cl->typ == 'p' && cl->reader->cacheex.mode == 3)
+			{
+				cl->reader->cacheex.localgenerated_only = buf[24];
+			}
+			break;
+		// set localgenerated only caidtab
+		case 2:
+			filter_count = buf[i+4];
+			i += 5;
+
+			CAIDTAB *lgonly_ctab;
+			memset(&lgonly_ctab, 0, sizeof(lgonly_ctab));
+			
+			if(cl->typ == 'c' && cl->account->cacheex.mode == 2)
+			{
+				lgonly_ctab = &cl->account->cacheex.localgenerated_only_caidtab;
+			}
+			else if(cl->typ == 'p' && cl->reader->cacheex.mode == 3)
+			{
+				lgonly_ctab = &cl->reader->cacheex.localgenerated_only_caidtab;
+			}
+
+			caidtab_clear(lgonly_ctab);
+
+			for(j = 0; j < filter_count; j++)
+			{
+				CAIDTAB_DATA d;
+				memset(&d, 0, sizeof(d));
+				d.mask = 0xffff;
+				d.caid = b2i(2, buf + i);
+				i += 2;
+				caidtab_add(lgonly_ctab, &d);
+			}
+			break;
+		// set cacheex_ecm_filter - extended
+		case 4:
+			filter_count = buf[i+4];
+			i += 5;
+
+			CECSPVALUETAB *filter;
+			memset(&filter, 0, sizeof(filter));
+			
+			if(cl->typ == 'c' && cl->account->cacheex.mode == 2 && cl->account->cacheex.allow_filter)
+			{
+				filter = &cl->account->cacheex.filter_caidtab;
+			}
+			else if(cl->typ == 'p' && cl->reader->cacheex.mode == 3 && cl->reader->cacheex.allow_filter)
+			{
+				filter = &cl->reader->cacheex.filter_caidtab;
+			}
+
+			cecspvaluetab_clear(filter);
+
+			for(j = 0; j < filter_count; j++)
+			{
+				int32_t caid = -1, cmask = -1, provid = -1, srvid = -1;
+				CECSPVALUETAB_DATA d;
+				memset(&d, 0, sizeof(d));
+				
+				caid = b2i(2, buf + i);
+				if(caid == 0xFFFF) caid = -1;
+				i += 2;
+				
+				cmask = b2i(2, buf + i);
+				if(cmask == 0xFFFF) cmask = -1;
+				i += 2;
+
+				provid = b2i(3, buf + i);
+				if(provid == 0xFFFFFF) provid = -1;
+				i += 3;
+
+				srvid = b2i(2, buf + i);
+				if(srvid == 0xFFFF) srvid = -1;
+				i += 2;
+				
+				if(caid > 0)
+				{
+					d.caid = caid;
+					d.cmask = cmask;
+					d.prid = provid;
+					d.srvid = srvid;
+					cecspvaluetab_add(filter, &d);
+				}
+			}
+			break;
+		// no push after
+		case 8: ;
+			CAIDVALUETAB *ctab;
+			memset(&ctab, 0, sizeof(ctab));
+
+			if(cl->typ == 'c' && cl->account->cacheex.mode == 2)
+				{
+					ctab = &cl->account->cacheex.cacheex_nopushafter_tab;
+				}
+				else if(cl->typ == 'p' && cl->reader->cacheex.mode == 3)
+				{
+					ctab = &cl->reader->cacheex.cacheex_nopushafter_tab;
+				}
+
+			filter_count = buf[i+4];
+			i += 5;
+			
+			caidvaluetab_clear(ctab);
+
+			for(j = 0; j < filter_count; j++)
+			{
+				uint16_t caid = 0, value = 0;
+				CAIDVALUETAB_DATA d;
+				memset(&d, 0, sizeof(d));
+
+				caid = b2i(2, buf + i);
+				if(caid == 0xFFFF) caid = -1;
+				i += 2;
+				
+				value = b2i(2, buf + i);
+				if(value == 0xFFFF) value = -1;
+				i += 2;
+				
+				if(caid > 0)
+				{
+					d.caid = caid;
+					d.value = value;
+					caidvaluetab_add(ctab, &d);
+				}
+			}
+			break;
+		// max hop
+		case 16:
+			if(cl->typ == 'c' && cl->account->cacheex.mode == 2 && cl->account->cacheex.allow_maxhop)
+			{
+				cl->account->cacheex.maxhop = buf[24];
+			}
+			else if(cl->typ == 'p' && cl->reader->cacheex.mode == 3 && cl->reader->cacheex.allow_maxhop)
+			{
+				cl->reader->cacheex.maxhop = buf[24];
+			}
+			break;
+		// aio-version
+		case 32:
+			if(cl->typ == 'c' && cl->account->cacheex.mode > 1)
+			{
+				char *ofs = (char *)buf + i + 4;
+				cs_strncpy(cl->account->cacheex.aio_version, ofs, sizeof(cl->account->cacheex.aio_version));
+			}
+			else if(cl->typ == 'p' && cl->reader->cacheex.mode > 1)
+			{
+				char *ofs = (char *)buf + i + 4;
+				cs_strncpy(cl->reader->cacheex.aio_version, ofs, sizeof(cl->reader->cacheex.aio_version));
+			}
+			break;
+		default:
+			return;
+	}
+}
+
+void camd35_cacheex_feature_trigger(struct s_client *cl, int32_t feature, uint8_t mode)
+{
+	// size: 20 + (feature-bitfield & mask: 2) + payload-size: 2 + feature-payload :x
+	uint16_t size = 20 + 2 + 2;
+	int i = 0;
+	uint8_t j;
+	uint8_t payload[MAX_ECM_SIZE-size]; 
+	memset(payload, 0, sizeof(payload));
+
+	switch(feature)
+	{
+		// set localgenerated only
+		case 1:
+			size += 1;
+			if(size < 32)
+				size = 32;
+
+			// bitfield
+			i2b_buf(2, feature, payload + i);
+			i += 2;
+			// payload-size
+			i2b_buf(2, 1, payload + i);
+			i += 2;
+			// set payload
+			if(mode == 2)
+			{
+				if(cl->reader->cacheex.localgenerated_only_in)
+					payload[i] = cl->reader->cacheex.localgenerated_only_in;
+				else
+					payload[i] = cfg.cacheex_localgenerated_only_in;
+				i += 1;
+			}
+			else if(mode == 3)
+			{
+				if(cl->account->cacheex.localgenerated_only_in)
+					payload[i] = cl->account->cacheex.localgenerated_only_in;
+				else
+					payload[i] = cfg.cacheex_localgenerated_only_in;
+				i += 1;
+			}
+			
+			break;
+		// set localgenerated only caidtab
+		case 2: ;
+			CAIDTAB *lgonly_ctab;
+			if(mode == 2)
+			{
+				lgonly_ctab = &cl->reader->cacheex.localgenerated_only_in_caidtab;
+				if(!lgonly_ctab->ctnum)
+					lgonly_ctab = &cfg.cacheex_localgenerated_only_in_caidtab;
+			}
+			else if(mode == 3)
+			{
+				lgonly_ctab = &cl->account->cacheex.localgenerated_only_in_caidtab;
+				if(!lgonly_ctab->ctnum)
+					lgonly_ctab = &cfg.cacheex_localgenerated_only_in_caidtab;
+			}
+			else
+			{
+				return;
+			}
+
+			size += (lgonly_ctab->ctnum * 2 + 1);
+			if(size < 32)
+				size = 32;
+
+			// bitfield
+			i2b_buf(2, feature, payload + i);
+			i += 2;
+			// payload-size
+			if((lgonly_ctab->ctnum * 2 + 1) > (int)sizeof(payload))
+			{
+				cs_log_dbg(D_CACHEEX, "ERROR: too much localgenerated only caidtab-entries (max. 255)");
+				return;
+			}
+			i2b_buf(2, (lgonly_ctab->ctnum * 2 + 1), payload + i); // n * caid + ctnum
+			i += 2;
+			// set payload
+			if(lgonly_ctab->ctnum > 255)
+			{
+				cs_log_dbg(D_CACHEEX, "ERROR: too much localgenerated only caidtab-entries (max. 255)");
+				return;
+			}
+			payload[i] = lgonly_ctab->ctnum;
+			i += 1;
+
+			for(j = 0; j < lgonly_ctab->ctnum; j++)
+			{
+				CAIDTAB_DATA *d = &lgonly_ctab->ctdata[j];
+				if(d->caid)
+				{
+					i2b_buf(2, d->caid, payload + i);
+					i += 2;
+				}
+				else
+				{
+					continue;
+				}
+			}
+			break;
+		// cacchex_ecm_filter extendend
+		case 4: ;
+			CECSPVALUETAB *filter;
+			if(mode == 2)
+			{
+				filter = &cl->reader->cacheex.filter_caidtab;
+				// if not set, use global settings
+				if(cl->reader->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab.cevnum > 0)
+					filter = &cfg.cacheex_filter_caidtab;
+				// if aio, use global aio settings
+				if(cl->reader->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab_aio.cevnum > 0 && cl->cacheex_aio_checked && (cl->reader->cacheex.feature_bitfield & 4))
+					filter = &cfg.cacheex_filter_caidtab_aio;
+			}
+			else if(mode == 3)
+			{
+
+				filter = &cl->account->cacheex.filter_caidtab;
+				// if not set, use global settings
+				if(cl->account->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab.cevnum > 0)
+					filter = &cfg.cacheex_filter_caidtab;
+				if(cl->account->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab_aio.cevnum > 0 && cl->cacheex_aio_checked && (cl->account->cacheex.feature_bitfield & 4))
+					filter = &cfg.cacheex_filter_caidtab_aio;
+			}
+			else
+			{
+				return;
+			}
+
+			size += (filter->cevnum * 9 + 1);
+			if(size < 32)
+				size = 32;
+
+			// bitfield
+			i2b_buf(2, feature, payload + i);
+			i += 2;
+			// payload-size
+			if((filter->cevnum * 9 + 1) > (int)sizeof(payload))
+			{
+				cs_log_dbg(D_CACHEEX, "ERROR: to much cacheex_ecm_filter-entries (max. 63), only 15 default camd3-filters sent");
+				return;
+			}
+			i2b_buf(2, (filter->cevnum * 9 + 1), payload + i); // n * (caid2,mask2,provid3,srvid2) + ctnum1
+			i += 2;
+			// set payload
+			payload[i] = filter->cevnum;
+			i += 1;
+
+			for(j = 0; j < filter->cevnum; j++)
+			{
+				CECSPVALUETAB_DATA *d = &filter->cevdata[j];
+				if(d->caid)
+				{
+					i2b_buf(2, d->caid, payload + i);
+					i += 2;
+				}
+				if(d->cmask)
+				{
+					i2b_buf(2, d->cmask, payload + i);
+				}
+				i += 2;
+
+				if(d->prid)
+				{
+					i2b_buf(3, d->prid, payload + i);
+				}
+				i += 3;
+
+				if(d->srvid)
+				{
+					i2b_buf(2, d->srvid, payload + i);
+				}
+				i += 2;
+			}
+
+			camd35_cacheex_send_push_filter(cl, 2);
+			break;
+		// no push after
+		case 8: ;
+			CAIDVALUETAB *ctab;
+			if(mode == 2)
+			{
+				ctab = &cl->reader->cacheex.cacheex_nopushafter_tab;
+				if(!ctab->cvnum)
+					ctab = &cfg.cacheex_nopushafter_tab;
+			}
+			else if(mode == 3)
+			{
+				ctab = &cl->account->cacheex.cacheex_nopushafter_tab;
+				if(!ctab->cvnum)
+					ctab = &cfg.cacheex_nopushafter_tab;
+			}
+			else
+			{
+				return;
+			}
+
+			size += (ctab->cvnum * 4 + 1);
+			if(size < 32)
+				size = 32;
+
+			// bitfield
+			i2b_buf(2, feature, payload + i);
+			i += 2;
+			// payload-size
+			if((ctab->cvnum * 4 + 1) > (int)sizeof(payload))
+			{
+				cs_log_dbg(D_CACHEEX, "ERROR: to much no push after caidtvalueab-entries (max. 255)");
+				return;
+			}
+			i2b_buf(2, (ctab->cvnum * 4 + 1), payload + i); // n * (caid2+value2) + cvnum
+			i += 2;
+			// set payload
+			if(ctab->cvnum > 255)
+			{
+				cs_log_dbg(D_CACHEEX, "ERROR: to much no push after caidtvalueab-entries (max. 255)");
+				return;
+			}
+			payload[i] = ctab->cvnum;
+			i += 1;
+
+			for(j = 0; j < ctab->cvnum; j++)
+			{
+				CAIDVALUETAB_DATA *d = &ctab->cvdata[j];
+				if(d->caid)
+				{
+					i2b_buf(2, d->caid, payload + i);
+					i += 2;
+					i2b_buf(2, d->value, payload + i);
+					i += 2;
+				}
+				else
+				{
+					continue;
+				}
+			}
+			break;
+		// maxhop
+		case 16:
+			size += 1;
+			if(size < 32)
+				size = 32;
+
+			// bitfield
+			i2b_buf(2, feature, payload + i);
+			i += 2;
+			// payload-size
+			i2b_buf(2, 1, payload + i);
+			i += 2;
+			// set payload
+			if(mode == 2)
+			{
+				if(cl->reader->cacheex.maxhop)
+					payload[i] = cl->reader->cacheex.maxhop;
+				else
+					payload[i] = 0;
+				i += 1;
+			}
+			else if(mode == 3)
+			{
+				if(cl->account->cacheex.maxhop)
+					payload[i] = cl->account->cacheex.maxhop;
+				else
+					payload[i] = 0;
+				i += 1;
+			}
+			break;
+		// aio-version
+		case 32: ;
+			size += 12;
+			if(size < 32)
+				size = 32;
+
+			uint8_t token[12];
+
+			// bitfield
+			i2b_buf(2, feature, payload + i);
+			i += 2;
+			// payload-size
+			i2b_buf(2, sizeof(token), payload + i);
+			i += 2;
+			// set payload
+			
+			snprintf((char *)token, sizeof(token), "%s", CS_AIO_VERSION);
+			uint8_t *ofs = payload + i;
+			memcpy(ofs, token, sizeof(token));
+			break;
+		default:
+			return;
+	}
+	uint8_t buf[size];
+	memset(buf, 0, sizeof(buf));
+	buf[0] = 0x42;	// camd35_cacheex_feature_trigger
+	
+	buf[1] = (size - 20) & 0xFF;
+	buf[2] = (size - 20) >> 8;
+	
+	uint8_t *ofs = buf + 20;
+	memcpy(ofs, payload, size - 20);
+
+	camd35_send_without_timeout(cl, buf, size-20); //send adds +20
+}
+
+void camd35_cacheex_feature_request_save(struct s_client *cl, uint8_t *buf)
+{
+	int32_t field = b2i(2, (buf+20));
+	if(cl->typ == 'c' && cl->account->cacheex.mode == 2)
+	{
+		cl->account->cacheex.feature_bitfield = field;
+		// flag 32 => aio-version
+		if(cl->account->cacheex.feature_bitfield & 32)
+		{
+			camd35_cacheex_feature_trigger(cl, 32, 2);
+		}
+	}
+
+	if(cl->typ == 'p' && cl->reader->cacheex.mode == 3)
+	{
+		cl->reader->cacheex.feature_bitfield = field;
+		// flag 32 => aio-version
+		if(cl->reader->cacheex.feature_bitfield & 32)
+		{
+			camd35_cacheex_feature_trigger(cl, 32, 3);
+		}
+	}
+
+	if(cl->typ == 'c' && cl->account->cacheex.mode == 3)
+	{
+		struct s_auth *acc = cl->account;
+		if(acc)
+		{
+			acc->cacheex.feature_bitfield = field;
+			// process feature-specific actions based on feature_bitfield received
+			
+			// flag 1 => set localgenerated only flag
+			if(acc->cacheex.feature_bitfield & 1)
+			{
+				camd35_cacheex_feature_trigger(cl, 1, 3);
+			}
+			// flag 2 => set localgenerated only caids flag
+			if(acc->cacheex.feature_bitfield & 2)
+			{
+				camd35_cacheex_feature_trigger(cl, 2, 3);
+			}
+			// flag 4 => set cacheex_ecm_filter (extended)
+			if(acc->cacheex.feature_bitfield & 4)
+			{
+				camd35_cacheex_feature_trigger(cl, 4, 3);
+			}
+			// flag 8 => np push after caids
+			if(acc->cacheex.feature_bitfield & 8)
+			{
+				camd35_cacheex_feature_trigger(cl, 8, 3);
+			}
+			// flag 16 => maxhop
+			if(acc->cacheex.feature_bitfield & 16)
+			{
+				camd35_cacheex_feature_trigger(cl, 16, 3);
+			}
+			// flag 32 => aio-version
+			if(acc->cacheex.feature_bitfield & 32)
+			{
+				camd35_cacheex_feature_trigger(cl, 32, 3);
+			}
+		}
+		else
+		{
+			cs_log_dbg(D_CACHEEX, "feature_bitfield save failed - cl, %s", username(cl));
+		}
+	}
+	else if(cl->typ == 'p' && cl->reader->cacheex.mode == 2)
+	{
+		struct s_reader *rdr = cl->reader;
+		if(rdr)
+		{
+			rdr->cacheex.feature_bitfield = field;
+			// process feature-specific actions
+
+			// flag 1 => set localgenerated_only; cause of rdr->cacheex.localgenerated_only_in is set
+			if(rdr->cacheex.feature_bitfield & 1)
+			{
+				camd35_cacheex_feature_trigger(cl, 1, 2);
+			}
+			
+			// flag 2 => set localgenerated_only_caidtab; cause of rdr->cacheex.localgenerated_only_in_caidtab is set
+			if(rdr->cacheex.feature_bitfield & 2)
+			{
+				camd35_cacheex_feature_trigger(cl, 2, 2);
+			}
+
+			// flag 4 => set localgenerated_only_caidtab; cause of rdr->cacheex.localgenerated_only_in_caidtab is set
+			if(rdr->cacheex.feature_bitfield & 4)
+			{
+				camd35_cacheex_feature_trigger(cl, 4, 2);
+			}
+
+			// flag 8 => np push after caids
+			if(rdr->cacheex.feature_bitfield & 8)
+			{
+				camd35_cacheex_feature_trigger(cl, 8, 2);
+			}
+			// flag 16 => maxhop
+			if(rdr->cacheex.feature_bitfield & 16)
+			{
+				camd35_cacheex_feature_trigger(cl, 16, 2);
+			}
+			// flag 32 => aio-version
+			if(rdr->cacheex.feature_bitfield & 32)
+			{
+				camd35_cacheex_feature_trigger(cl, 32, 2);
+			}
+		}
+		else
+		{
+			cs_log_dbg(D_CACHEEX, "feature_bitfield save failed - rdr, %s", username(cl));
+		}
+	}
+}
+
+void camd35_cacheex_feature_request(struct s_client *cl)
+{
+	int i = 20;
+
+	uint8_t buf[32];
+	memset(buf, 0, sizeof(buf));
+	buf[0] = 0x40;
+	buf[1] = 12;
+	buf[2] = 0;
+
+	i2b_buf(2, CACHEEX_FEATURES, buf + i); // set feature-list here
+	i += 2;
+
+	camd35_send_without_timeout(cl, buf, 12); //send adds +20
+}
+
+void camd35_cacheex_feature_request_reply(struct s_client *cl, uint8_t *buf)
+{
+	camd35_cacheex_feature_request_save(cl, buf);
+	int i = 20;
+
+	uint8_t rbuf[32];
+	memset(rbuf, 0, sizeof(rbuf));
+	rbuf[0] = 0x41;
+	rbuf[1] = 12;
+	rbuf[2] = 0;
+	
+	i2b_buf(2, CACHEEX_FEATURES, rbuf + i);
+	i += 2;
+
+	camd35_send_without_timeout(cl, rbuf, 12); //send adds +20
+}
+
+
+
 /**
  * send push filter
  */
@@ -39,11 +664,17 @@
 	if(mode == 2 && rdr)
 	{
 		filter = &rdr->cacheex.filter_caidtab;
+		// if not set, use global settings
+		if(rdr->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab.cevnum > 0)
+			filter = &cfg.cacheex_filter_caidtab;
 	}
 	//mode==3 send filters from acc
 	else if(mode == 3 && cl->typ == 'c' && cl->account)
 	{
 		filter = &cl->account->cacheex.filter_caidtab;
+		// if not set, use global settings
+		if(cl->account->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab.cevnum > 0)
+			filter = &cfg.cacheex_filter_caidtab;
 	}
 	else {
 		return;
@@ -241,7 +872,7 @@
 	}
 
 	uint32_t size = sizeof(er->ecmd5) + sizeof(er->csp_hash) + sizeof(er->cw) + sizeof(uint8_t) +
-					(ll_count(er->csp_lastnodes) + 1) * 8;
+					(ll_count(er->csp_lastnodes) + 1) * 8 + sizeof(uint8_t);
 	uint8_t *buf;
 	if(!cs_malloc(&buf, size + 20))  //camd35_send() adds +20
 		{ return -1; }
@@ -304,6 +935,17 @@
 	}
 	ll_li_destroy(li);
 
+	// add localgenerated cw-flag
+	if(er->localgenerated)
+	{
+		*ofs = 1;
+	}
+	else
+	{
+		*ofs = 0xFF;
+	}
+	ofs += 1;
+
 	int32_t res = camd35_send(cl, buf, size);
 	NULLFREE(buf);
 	return res;
@@ -349,15 +991,6 @@
 		}
 	}
 
-	if (er->cwc_cycletime && er->cwc_next_cw_cycle < 2)
-	{
-		if(cl->typ == 'c' && cl->account && cl->account->cacheex.mode)
-			{ cl->account->cwc_info++; }
-		else if((cl->typ == 'p' || cl->typ == 'r') && (cl->reader && cl->reader->cacheex.mode))
-			{ cl->cwc_info++; }
-		cs_log_dbg(D_CWC, "CWC (CE) received from %s cycletime: %isek - nextcwcycle: CW%i for %04X@%06X:%04X", username(cl), er->cwc_cycletime, er->cwc_next_cw_cycle, er->caid, er->prid, er->srvid);
-	}
-
 	uint8_t *ofs = buf + 20;
 
 	//Read ecmd5
@@ -367,6 +1000,35 @@
 	if(!check_cacheex_filter(cl, er))
 		{ return; }
 
+	// check incoming cache
+	if(check_client(cl) && cl->typ == 'p' && cl->reader && cl->reader->cacheex.mode == 2
+		&& 	(		(cl->reader->cacheex.filter_caidtab.cevnum > 0 && !chk_csp_ctab(er, &cl->reader->cacheex.filter_caidtab)) // reader cacheex_ecm_filter not matching if set
+				|| 	(cl->reader->cacheex.filter_caidtab.cevnum == 0 && (cl->reader->cacheex.feature_bitfield & 4) && cfg.cacheex_filter_caidtab_aio.cevnum > 0 && !chk_csp_ctab(er, &cfg.cacheex_filter_caidtab_aio)) // global cacheex_ecm_filter_aio not matching if set
+				|| 	(cl->reader->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab_aio.cevnum == 0 && cfg.cacheex_filter_caidtab.cevnum > 0 && !chk_csp_ctab(er, &cfg.cacheex_filter_caidtab)) // global cacheex_ecm_filter not matching if set
+			)
+	)
+	{
+		cs_log_dbg(D_CACHEEX, "cacheex: received cache not matching cacheex_ecm_filter => pushing filter again");
+		camd35_cacheex_send_push_filter(cl, 2);	// get cache != cacheex_ecm_filter, send filter again - remote restarted
+		if(cl->reader->cacheex.feature_bitfield & 4)
+			camd35_cacheex_feature_trigger(cl, 4, 2);
+		return;
+	}
+
+	if(check_client(cl) && cl->typ == 'c' && cl->account && cl->account->cacheex.mode == 3
+		&& 	(		(cl->account->cacheex.filter_caidtab.cevnum > 0 && !chk_csp_ctab(er, &cl->account->cacheex.filter_caidtab)) // account cacheex_ecm_filter not matching if set
+				|| 	(cl->account->cacheex.filter_caidtab.cevnum == 0 && (cl->account->cacheex.feature_bitfield & 4) && cfg.cacheex_filter_caidtab_aio.cevnum > 0 && !chk_csp_ctab(er, &cfg.cacheex_filter_caidtab_aio)) // global cacheex_ecm_filter_aio not matching if set
+				|| 	(cl->account->cacheex.filter_caidtab.cevnum == 0 && cfg.cacheex_filter_caidtab_aio.cevnum == 0 && cfg.cacheex_filter_caidtab.cevnum > 0 && !chk_csp_ctab(er, &cfg.cacheex_filter_caidtab)) // global cacheex_ecm_filter not matching if set
+			)
+	)
+	{
+		cs_log_dbg(D_CACHEEX, "cacheex: received cache not matching cacheex_ecm_filter => pushing filter again");
+		camd35_cacheex_send_push_filter(cl, 3); // get cache != cacheex_ecm_filter, send filter again - remote restarted
+		if(cl->account->cacheex.feature_bitfield & 4)
+			camd35_cacheex_feature_trigger(cl, 4, 3);
+		return;
+	}
+
 	//Read csp_hash:
 	er->csp_hash = CSP_HASH_SWAP(b2i(4, ofs));
 	ofs += 4;
@@ -405,6 +1067,61 @@
 			count--;
 			cs_log_dbg(D_CACHEEX, "cacheex: received node %" PRIu64 "X %s", cacheex_node_id(data), username(cl));
 		}
+
+		// check byte after nodelist for "localgenerated CW"-flag
+		if(b2i(1, ofs) == 1)
+		{
+			er->localgenerated = 1;
+			cs_log_dbg(D_CACHEEX, "cacheex: received ECM with localgenerated flag %04X@%06X:%04X %s", er->caid, er->prid, er->srvid, username(cl));
+		}
+		// without localgenerated flag
+		else
+		{
+			if(
+				(cl->typ == 'p' && cl->reader && cl->reader->cacheex.mode == 2 && !chk_srvid_localgenerated_only_exception(er) // cx2
+					&& (
+						// !aio
+						(cl->cacheex_aio_checked && !cl->reader->cacheex.feature_bitfield
+							&& (
+								!cfg.cacheex_lg_only_in_aio_only && !cl->reader->cacheex.lg_only_in_aio_only 
+								&& (cfg.cacheex_localgenerated_only_in || cl->reader->cacheex.localgenerated_only_in || chk_ctab_ex(er->caid, &cl->reader->cacheex.localgenerated_only_in_caidtab) || chk_ctab_ex(er->caid, &cfg.cacheex_localgenerated_only_in_caidtab))
+							)
+						)
+						||
+						// aio
+						(cl->cacheex_aio_checked && cl->reader->cacheex.feature_bitfield
+							&& (
+								cfg.cacheex_localgenerated_only_in || cl->reader->cacheex.localgenerated_only_in || chk_ctab_ex(er->caid, &cl->reader->cacheex.localgenerated_only_in_caidtab) || chk_ctab_ex(er->caid, &cfg.cacheex_localgenerated_only_in_caidtab)
+							)
+						)
+					)
+				)
+				||
+				(cl->typ == 'c' && cl->account && cl->account->cacheex.mode == 3 && !chk_srvid_localgenerated_only_exception(er) // cx3
+					&& (
+						// !aio
+						(cl->cacheex_aio_checked && !cl->account->cacheex.feature_bitfield
+							&& (
+								!cfg.cacheex_lg_only_in_aio_only && !cl->account->cacheex.lg_only_in_aio_only 
+								&& (cfg.cacheex_localgenerated_only_in || cl->account->cacheex.localgenerated_only_in || chk_ctab_ex(er->caid, &cl->account->cacheex.localgenerated_only_in_caidtab) || chk_ctab_ex(er->caid, &cfg.cacheex_localgenerated_only_in_caidtab))
+							)
+						)
+						||
+						// aio
+						(cl->cacheex_aio_checked && cl->account->cacheex.feature_bitfield
+							&& (
+								cfg.cacheex_localgenerated_only_in || cl->account->cacheex.localgenerated_only_in || chk_ctab_ex(er->caid, &cl->account->cacheex.localgenerated_only_in_caidtab) || chk_ctab_ex(er->caid, &cfg.cacheex_localgenerated_only_in_caidtab)
+							)
+						)
+					)
+				)
+			)
+			{
+				cs_log_dbg(D_CACHEEX, "cacheex: drop ECM without localgenerated flag %04X@%06X:%04X %s", er->caid, er->prid, er->srvid, username(cl));
+				free_push_in_ecm(er);
+				return;
+			}
+		}
 	}
 	else
 	{
@@ -431,6 +1148,15 @@
 		cs_log_dbg(D_CACHEEX, "cacheex: added missing remote node id %" PRIu64 "X", cacheex_node_id(data));
 	}
 
+	if (er->cwc_cycletime && er->cwc_next_cw_cycle < 2)
+	{
+		if(cl->typ == 'c' && cl->account && cl->account->cacheex.mode)
+			{ cl->account->cwc_info++; }
+		else if((cl->typ == 'p' || cl->typ == 'r') && (cl->reader && cl->reader->cacheex.mode))
+			{ cl->cwc_info++; }
+		cs_log_dbg(D_CWC, "CWC (CE) received from %s cycletime: %isek - nextcwcycle: CW%i for %04X@%06X:%04X", username(cl), er->cwc_cycletime, er->cwc_next_cw_cycle, er->caid, er->prid, er->srvid);
+	}
+
 	cacheex_add_to_cache(cl, er);
 }
 
@@ -562,6 +1288,11 @@
 			camd35_cacheex_send_push_filter(client, 3);
 			client->cacheex_needfilter = 0;
 		}
+		if(!client->cacheex_aio_checked && ((client->account && client->account->cacheex.mode > 1) || (client->reader && client->reader->cacheex.mode > 1)))
+		{
+			camd35_cacheex_feature_request(client);
+			client->cacheex_aio_checked = 1;
+		}
 		break;
 	case 0x3e:  // Cache-push id answer
 		camd35_cacheex_push_receive_remote_id(client, mbuf);
@@ -569,6 +1300,15 @@
 	case 0x3f:  // Cache-push
 		camd35_cacheex_push_in(client, mbuf);
 		break;
+	case 0x40:	// cacheex-features request
+		camd35_cacheex_feature_request_reply(client, mbuf);
+		break;
+	case 0x41:	// cacheex-features answer
+		camd35_cacheex_feature_request_save(client, mbuf);		
+		break;
+	case 0x42:	// cacheex-feature trigger in
+		camd35_cacheex_feature_trigger_in(client, mbuf);
+		break;
 	default:
 		return 0; // Not processed by cacheex
 	}
@@ -591,10 +1331,24 @@
 		break;
 	case 0x3e:     // Cache-push id answer
 		camd35_cacheex_push_receive_remote_id(client, buf);
+		if(!client->cacheex_aio_checked && ((client->account && client->account->cacheex.mode > 1) || (client->reader && client->reader->cacheex.mode > 1)))
+		{
+			camd35_cacheex_feature_request(client);
+			client->cacheex_aio_checked = 1;
+		}
 		break;
 	case 0x3f:    //cache-push
 		camd35_cacheex_push_in(client, buf);
 		break;
+	case 0x40:	  // cacheex-features request
+		camd35_cacheex_feature_request_reply(client, buf);
+		break;		
+	case 0x41:	// cacheex-features answer
+		camd35_cacheex_feature_request_save(client, buf);
+		break;
+	case 0x42:	// cacheex-feature trigger in
+		camd35_cacheex_feature_trigger_in(client, buf);
+		break;
 	default:
 		return 0; // Not processed by cacheex
 	}
Index: module-camd35-cacheex.h
===================================================================
--- module-camd35-cacheex.h	(revision 11581)
+++ module-camd35-cacheex.h	(working copy)
@@ -9,6 +9,7 @@
 bool camd35_cacheex_server(struct s_client *client, uint8_t *mbuf);
 bool camd35_cacheex_recv_chk(struct s_client *client, uint8_t *buf);
 void camd35_cacheex_module_init(struct s_module *ph);
+void camd35_cacheex_feature_request(struct s_client *cl);
 #else
 static inline void camd35_cacheex_init_dcw(struct s_client *UNUSED(client), ECM_REQUEST *UNUSED(er)) { }
 static inline void camd35_cacheex_recv_ce1_cwc_info(struct s_client *UNUSED(cl), uint8_t *UNUSED(buf), int32_t UNUSED(idx)) { }
Index: module-camd35.c
===================================================================
--- module-camd35.c	(revision 11581)
+++ module-camd35.c	(working copy)
@@ -316,7 +316,7 @@
 				{
 					buflen = (((buf[21] & 0x0F) << 8) | buf[22]) + 3;
 				}
-				else if(buf[0] == 0x3D || buf[0] == 0x3E || buf[0] == 0x3F) // cacheex-push
+				else if(buf[0] == 0x40 || buf[0] == 0x41 || buf[0] == 0x42 || buf[0] == 0x3D || buf[0] == 0x3E || buf[0] == 0x3F) // cacheex-push
 				{
 					buflen = buf[1] | (buf[2] << 8);
 				}
@@ -864,6 +864,7 @@
 	if(cacheex_get_rdr_mode(cl->reader) == 2)
 	{
 		camd35_cacheex_send_push_filter(cl, 2);
+		camd35_cacheex_feature_request(cl);
 	}
 
 	return 0;
